/**
 * <copyright>
 * </copyright>
 *
 * $Id: TabPageImpl.java 5810 2010-05-26 19:48:27Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.BoolLiteral;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.dom.model.ConditionsBlock;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.ComposeData;
import org.openxma.dsl.pom.model.Composite;
import org.openxma.dsl.pom.model.Content;
import org.openxma.dsl.pom.model.DataMappingList;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.Definitions;
import org.openxma.dsl.pom.model.EventMappingList;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.ITabPage;
import org.openxma.dsl.pom.model.LabelText;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.PageDefinition;
import org.openxma.dsl.pom.model.TabPage;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tab Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TabPageImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TabPageImpl#getLabelText <em>Label Text</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TabPageImpl#getScrollable <em>Scrollable</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TabPageImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TabPageImpl#getPageProperties <em>Page Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TabPageImpl extends ITabPageImpl implements TabPage {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLabelText() <em>Label Text</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLabelText()
	 * @generated
	 * @ordered
	 */
	protected LabelText labelText;

	/**
	 * The cached value of the '{@link #getScrollable() <em>Scrollable</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScrollable()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral scrollable;

	/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

	/**
	 * The cached value of the '{@link #getPageProperties() <em>Page Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPageProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<ObjectProperty> pageProperties;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TabPageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.TAB_PAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TAB_PAGE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LabelText getLabelText() {
		return labelText;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLabelText(LabelText newLabelText, NotificationChain msgs) {
		LabelText oldLabelText = labelText;
		labelText = newLabelText;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TAB_PAGE__LABEL_TEXT, oldLabelText, newLabelText);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLabelText(LabelText newLabelText) {
		if (newLabelText != labelText) {
			NotificationChain msgs = null;
			if (labelText != null)
				msgs = ((InternalEObject)labelText).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TAB_PAGE__LABEL_TEXT, null, msgs);
			if (newLabelText != null)
				msgs = ((InternalEObject)newLabelText).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TAB_PAGE__LABEL_TEXT, null, msgs);
			msgs = basicSetLabelText(newLabelText, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TAB_PAGE__LABEL_TEXT, newLabelText, newLabelText));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getScrollable() {
		return scrollable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetScrollable(BoolLiteral newScrollable, NotificationChain msgs) {
		BoolLiteral oldScrollable = scrollable;
		scrollable = newScrollable;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TAB_PAGE__SCROLLABLE, oldScrollable, newScrollable);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScrollable(BoolLiteral newScrollable) {
		if (newScrollable != scrollable) {
			NotificationChain msgs = null;
			if (scrollable != null)
				msgs = ((InternalEObject)scrollable).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TAB_PAGE__SCROLLABLE, null, msgs);
			if (newScrollable != null)
				msgs = ((InternalEObject)newScrollable).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TAB_PAGE__SCROLLABLE, null, msgs);
			msgs = basicSetScrollable(newScrollable, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TAB_PAGE__SCROLLABLE, newScrollable, newScrollable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.TAB_PAGE__FIELD_FLAGS);
		}
		return fieldFlags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ObjectProperty> getPageProperties() {
		if (pageProperties == null) {
			pageProperties = new EObjectContainmentEList<ObjectProperty>(ObjectProperty.class, this, PomPackage.TAB_PAGE__PAGE_PROPERTIES);
		}
		return pageProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.TAB_PAGE__LABEL_TEXT:
				return basicSetLabelText(null, msgs);
			case PomPackage.TAB_PAGE__SCROLLABLE:
				return basicSetScrollable(null, msgs);
			case PomPackage.TAB_PAGE__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.TAB_PAGE__PAGE_PROPERTIES:
				return ((InternalEList<?>)getPageProperties()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.TAB_PAGE__NAME:
				return getName();
			case PomPackage.TAB_PAGE__LABEL_TEXT:
				return getLabelText();
			case PomPackage.TAB_PAGE__SCROLLABLE:
				return getScrollable();
			case PomPackage.TAB_PAGE__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.TAB_PAGE__PAGE_PROPERTIES:
				return getPageProperties();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.TAB_PAGE__NAME:
				setName((String)newValue);
				return;
			case PomPackage.TAB_PAGE__LABEL_TEXT:
				setLabelText((LabelText)newValue);
				return;
			case PomPackage.TAB_PAGE__SCROLLABLE:
				setScrollable((BoolLiteral)newValue);
				return;
			case PomPackage.TAB_PAGE__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.TAB_PAGE__PAGE_PROPERTIES:
				getPageProperties().clear();
				getPageProperties().addAll((Collection<? extends ObjectProperty>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.TAB_PAGE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PomPackage.TAB_PAGE__LABEL_TEXT:
				setLabelText((LabelText)null);
				return;
			case PomPackage.TAB_PAGE__SCROLLABLE:
				setScrollable((BoolLiteral)null);
				return;
			case PomPackage.TAB_PAGE__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.TAB_PAGE__PAGE_PROPERTIES:
				getPageProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.TAB_PAGE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PomPackage.TAB_PAGE__LABEL_TEXT:
				return labelText != null;
			case PomPackage.TAB_PAGE__SCROLLABLE:
				return scrollable != null;
			case PomPackage.TAB_PAGE__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.TAB_PAGE__PAGE_PROPERTIES:
				return pageProperties != null && !pageProperties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //TabPageImpl
