lexer grammar InternalPomDsl;
@header {
package org.openxma.dsl.pom.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;
}

T15 : 'namespace' ;
T16 : 'enabled' ;
T17 : '=' ;
T18 : 'mandatory' ;
T19 : 'visible' ;
T20 : 'collapsed' ;
T21 : 'editable' ;
T22 : 'label' ;
T23 : 'public' ;
T24 : 'property' ;
T25 : 'readonly' ;
T26 : 'required' ;
T27 : 'component' ;
T28 : 'xma' ;
T29 : '::' ;
T30 : 'uses' ;
T31 : ',' ;
T32 : '{' ;
T33 : '}' ;
T34 : 'page' ;
T35 : 'content' ;
T36 : 'panel' ;
T37 : 'hpanel' ;
T38 : 'vpanel' ;
T39 : 'graylogic' ;
T40 : 'data' ;
T41 : '[]' ;
T42 : 'customize' ;
T43 : 'constraints' ;
T44 : 'format' ;
T45 : 'flags=' ;
T46 : 'tooltip' ;
T47 : 'unit' ;
T48 : '.' ;
T49 : '(' ;
T50 : ')' ;
T51 : '[' ;
T52 : ']' ;
T53 : 'multiline' ;
T54 : 'command' ;
T55 : 'uicommand' ;
T56 : 'eventmapping' ;
T57 : '->' ;
T58 : 'onInit' ;
T59 : 'onEnter' ;
T60 : 'onLeave' ;
T61 : 'databinding' ;
T62 : '<->' ;
T63 : 'abstract' ;
T64 : 'extends' ;
T65 : 'extend' ;
T66 : 'text' ;
T67 : 'align' ;
T68 : 'combo' ;
T69 : 'checkbox' ;
T70 : 'listbox' ;
T71 : 'tree' ;
T72 : 'radiobutton' ;
T73 : 'seperator' ;
T74 : 'orientation' ;
T75 : 'image' ;
T76 : 'uri' ;
T77 : 'button' ;
T78 : 'scrollable' ;
T79 : 'composite' ;
T80 : 'table' ;
T81 : 'key' ;
T82 : 'columnMinWidth' ;
T83 : 'multiselection' ;
T84 : 'oneway' ;
T85 : 'gridvisible' ;
T86 : 'sortindicator' ;
T87 : 'checkselection' ;
T88 : 'column' ;
T89 : 'width' ;
T90 : 'minWidth=' ;
T91 : 'maxWidth=' ;
T92 : 'tabfolder' ;
T93 : 'tabpage' ;
T94 : 'height' ;
T95 : 'style' ;
T96 : 'modality' ;
T97 : 'titlebuttons' ;
T98 : 'none' ;
T99 : 'resizeable' ;
T100 : 'true' ;
T101 : 'false' ;
T102 : 'tabulator' ;
T103 : '<' ;
T104 : '>' ;
T105 : 'cellwidths' ;
T106 : 'cellheights' ;
T107 : 'spacing' ;
T108 : 'margin' ;
T109 : ':' ;
T110 : 'string' ;
T111 : 'integer' ;
T112 : 'imageuri' ;
T113 : 'definitions' ;
T114 : 'auto' ;
T115 : 'stretch' ;
T116 : '+' ;
T117 : 'attachmentposition' ;
T118 : '%' ;
T119 : 'cell' ;
T120 : '|' ;
T121 : '&' ;
T122 : 'div' ;
T123 : 'tab' ;
T124 : '-' ;
T125 : 'select' ;
T126 : '#' ;
T127 : 'first-child' ;
T128 : 'middle-child' ;
T129 : 'last-child' ;
T130 : 'field-parts' ;
T131 : 'left' ;
T132 : 'right' ;
T133 : 'top' ;
T134 : 'bottom' ;
T135 : 'border-style' ;
T136 : 'solid' ;
T137 : 'foreground-color' ;
T138 : 'rgb' ;
T139 : 'background-color' ;
T140 : 'widget-variant' ;
T141 : 'font' ;
T142 : 'service' ;
T143 : 'operation' ;
T144 : 'valueobject' ;
T145 : 'dataview' ;
T146 : 'as' ;
T147 : 'all' ;
T148 : '.*' ;
T149 : 'entity' ;
T150 : 'id' ;
T151 : 'version' ;
T152 : 'composition' ;
T153 : 'oppositeof' ;
T154 : 'orderby' ;
T155 : 'available' ;
T156 : 'derived' ;
T157 : 'transient' ;
T158 : 'title' ;
T159 : 'description' ;
T160 : 'unique' ;
T161 : 'filter' ;
T162 : 'sortorder' ;
T163 : 'asc' ;
T164 : 'desc' ;
T165 : 'repository' ;
T166 : 'for' ;
T167 : 'discriminator' ;
T168 : 'qualifier' ;
T169 : 'usertype' ;
T170 : 'sqltype' ;
T171 : 'many-to-one' ;
T172 : 'one-to-one' ;
T173 : 'one-to-many' ;
T174 : 'many-to-many' ;
T175 : 'conditions' ;
T176 : 'function' ;
T177 : 'insert' ;
T178 : 'into' ;
T179 : 'delete' ;
T180 : 'from' ;
T181 : 'where' ;
T182 : 'update' ;
T183 : 'versioned' ;
T184 : 'set' ;
T185 : 'group' ;
T186 : 'by' ;
T187 : 'having' ;
T188 : 'order' ;
T189 : 'distinct' ;
T190 : 'new' ;
T191 : 'object' ;
T192 : 'in' ;
T193 : 'class' ;
T194 : 'elements' ;
T195 : 'join' ;
T196 : 'fetch' ;
T197 : 'with' ;
T198 : 'or' ;
T199 : 'and' ;
T200 : 'not' ;
T201 : 'is' ;
T202 : '!=' ;
T203 : '<>' ;
T204 : '<=' ;
T205 : '>=' ;
T206 : 'between' ;
T207 : 'like' ;
T208 : 'escape' ;
T209 : 'member' ;
T210 : 'of' ;
T211 : '||' ;
T212 : '*' ;
T213 : '/' ;
T214 : 'trim' ;
T215 : 'trailing' ;
T216 : 'leading' ;
T217 : 'both' ;
T218 : 'cast' ;
T219 : 'extract' ;
T220 : 'sum' ;
T221 : 'avg' ;
T222 : 'max' ;
T223 : 'min' ;
T224 : 'count' ;
T225 : 'some' ;
T226 : 'exists' ;
T227 : 'any' ;
T228 : 'case' ;
T229 : 'else' ;
T230 : 'end' ;
T231 : 'when' ;
T232 : 'then' ;
T233 : 'indices' ;
T234 : 'union' ;
T235 : 'null' ;
T236 : 'empty' ;
T237 : 'properties' ;
T238 : 'outer' ;
T239 : 'full' ;
T240 : 'inner' ;
T241 : 'import' ;
T242 : 'enum' ;
T243 : 'validation' ;
T244 : 'instancetype' ;
T245 : 'redefines' ;
T246 : '...' ;
T247 : 'doc:' ;
T248 : 'onClick' ;
T249 : 'onDoubleClick' ;
T250 : 'onSelection' ;
T251 : 'onDefaultSelection' ;
T252 : 'onExpand' ;
T253 : 'onCollapse' ;
T254 : 'closeOK' ;
T255 : 'closeCancel' ;
T256 : 'vcenter' ;
T257 : 'hcenter' ;
T258 : 'previous' ;
T259 : 'prev' ;
T260 : 'next' ;
T261 : 'center' ;
T262 : 'horizontal' ;
T263 : 'vertical' ;
T264 : 'control' ;
T265 : 'unitLabel' ;
T266 : 'editor' ;
T267 : 'minimize' ;
T268 : 'maximize' ;
T269 : 'close' ;
T270 : 'field' ;
T271 : 'create' ;
T272 : 'read' ;
T273 : 'crud' ;
T274 : 'index' ;
T275 : 'natural' ;
T276 : 'primary' ;
T277 : 'boolean' ;
T278 : '==' ;
T279 : 'getValue()' ;
T280 : 'hasValue()' ;
T281 : 'getSelectedValue()' ;
T282 : 'isSelected()' ;
T283 : 'getSelectionCount()' ;
T284 : 'size()' ;
T285 : 'isValid()' ;
T286 : 'number' ;
T287 : 'date' ;
T288 : 'timestamp' ;
T289 : 'enumeration' ;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29976
RULE_EXP_INT : RULE_INT ('e'|'E') ('-'|'+') RULE_INT;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29978
RULE_HEX : '0' ('x'|'X') ('0'..'9'|'a'..'f'|'A'..'F')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29980
RULE_REGION_START : '#region' ~(('\n'|'\r'))* ('\r'? '\n')?;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29982
RULE_REGION_END : '#endregion';

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29984
RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29986
RULE_INT : ('0'..'9')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29988
RULE_STRING : ('"' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'"')))* '"'|'\'' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'\'')))* '\'');

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29990
RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29992
RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29994
RULE_WS : (' '|'\t'|'\r'|'\n')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 29996
RULE_ANY_OTHER : .;


